#ifndef FUNCCOLONNA_H
#define FUNCCOLONNA_H
#include "Matrici.h"
#include "FunctionND.h"
#include <vector>
class FuncColonna  {

protected:
      int n;
      Colonna * _ymin;
      Colonna * _ymax;
      double _xmin, _xmax;
      vector<FunctionND> myself;
public:      
      FuncColonna():n(0),_ymin(0),_ymax(0) {};
      FuncColonna(int N,double xmin, double xmax):n(N),_ymin(0),_ymax(0) {
           _xmin=xmin;
           _xmax=xmax;
      };
      FuncColonna(int N, Colonna Pmin,Colonna Pmax, double xmin, double xmax):n(N) {
           _ymin=new Colonna(Pmin);
           _ymax=new Colonna(Pmax);
           _xmin=xmin;
           _xmax=xmax;
      };
      FuncColonna(const FuncColonna & C):n(C.n) {
          myself=C.myself;
           _xmin=C._xmin;
           _xmax=C._xmax;
           if (C._ymin!=0) _ymin=new Colonna(*(C._ymin));
           else _ymin=0;
           if (C._ymax!=0)_ymax=new Colonna(*(C._ymax));
           else _ymax=0;
      };
      virtual int M() const { return n;};
      virtual int N() const { return n;};
      virtual void add(FunctionND F) { myself.push_back(F); };
      virtual void add(double (*f) (Colonna P, double x)) ;
      void operator= (const FuncColonna & A) {
              if (n!= A.N() ) {
                 printf("richiesto di uguagliare FuncColonna non compatibili \n");
                 return ;        
              }
              n=A.N();
            

              myself=A.myself;
               _xmin=A._xmin;
               _xmax=A._xmax;
               if (A._ymin!=0)*_ymin=*(A._ymin);
               else _ymin=0;
               if (A._ymax!=0)*_ymax=*(A._ymax);
               else _ymax=0;
      };
//      virtual double operator[](int i) {return _el[0][i]; };
      FunctionND operator[](int j) { return myself[j]; };
      virtual ~FuncColonna() {};
      virtual void Print(const char * mess) {
            printf("%s\n",mess);

            printf ("\n");
      }
      Colonna operator() (Colonna P, double x) const {
              Colonna C(n);
              for (int k=0; k<n; k++) {
                  FunctionND F=myself[k];
                  C(k+1)=F(P,x);
              }   
              return C;
      };
                  
   double ymin(int i)  const { return (*_ymin)(i);};
   double ymax(int i)  const { return (*_ymax)(i); };
   double xmin() const { return _xmin; };
   double xmax() const { return _xmax; };
   void xmin(double x)  { _xmin=x; };
   void xmax(double x)  { _xmax=x; };
};

#endif
